// ProgressEX - Example demonstrates how to download a file from the internet
// using CInternetSession to accomplish the task, the following also calculates
// percentages, bytes received, kk's/sec and user cancelling operation.
//
// Written by Aviad Tobaly 2002
// Email : nuklear20@hotmail.com

#include "stdafx.h"
#include <wininet.h>
#include "ProgressEx.h"
#include "ProgressExDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int nTerminate = 0; // Cancelling Download variable
int nDownloaded = 0; // Downloaded complete verifier
/////////////////////////////////////////////////////////////////////////////
// CProgressExDlg dialog

CProgressExDlg::CProgressExDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProgressExDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProgressExDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CProgressExDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProgressExDlg)
	DDX_Control(pDX, IDC_FPROGRESS, m_Prog);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CProgressExDlg, CDialog)
	//{{AFX_MSG_MAP(CProgressExDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_GETFILE, OnGetFile)
	ON_BN_CLICKED(IDC_EXITCANCEL, OnExitCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProgressExDlg message handlers

BOOL CProgressExDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	SetDlgItemText(IDC_FILE,"http://idevnet.ca/tbattleclearlines.png");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CProgressExDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CProgressExDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


UINT DownloadFile(LPVOID pParam)
{
	// Worker thread, used to download our file seperatly so
	// downloading the file would not block the main application and
	// would give us an option to cancel the file transfer
	// 
	// NOTE : Every line in this code is commented for full
	// understanding of the code, excuse me for the english
	// when it comes to the spelling :)

	CWnd* pwnd = AfxGetMainWnd(); // Pointer to main window
	// Pointer to our progress bar....must have..
	CProgressCtrl* m_Prog = (CProgressCtrl*)pwnd->GetDlgItem(IDC_FPROGRESS);
	// Pointer to the Get File button
	CButton* bGetFile = (CButton*)pwnd->GetDlgItem(IDC_GETFILE);

	char filebuf[512]; // Buffer to store incoming file bytes
	CInternetSession netSession; // Our internetsession object
	CStdioFile *fTargFile; // Pointer to the target file
	CString szFile,FileSize,KBin,KBsec,NewName,Perc; // String variables
	pwnd->GetDlgItemText(IDC_FILE,szFile); // Get the file name from editbox
	int outfs; // File size variable
	// Try & Catch, if an error occours, we want to get it!
	try
	{
	pwnd->SetDlgItemText(IDC_STATUS,"Requesting file"); // Set status bar text
	// Open the file which will return a pointer to StdioFile object..
	fTargFile = netSession.OpenURL(szFile,1,INTERNET_FLAG_TRANSFER_BINARY | INTERNET_FLAG_RELOAD);
	nDownloaded = 1; // File has been found, downloading starts
	// Get the starting time of the download(kb/sec calculation)
	COleDateTime dlStart = COleDateTime::GetCurrentTime();
	
	int filesize = fTargFile->SeekToEnd(); // Get file size
	fTargFile->SeekToBegin(); // Move cursor back to top for reading

	outfs = filesize / 1024; // Calculate file size in kilobytes
	FileSize.Format("%d",outfs); // Format file size in kb into string
	// Create new destination file...
	CFile fDestFile(fTargFile->GetFileName(), CFile::modeCreate | CFile::modeWrite | CFile::typeBinary);
	
	int byteswrite; // Number of bytes to write into the file
	int pos = 0; // Position for our progress bar
	int nperc,kbrecv; // Percentage of progress,kbs received
	double secs,kbsec; // Seconds, kb/sec


	// If filename is too long, shorten it for Window's caption
	// status display
		
	NewName = fTargFile->GetFileName(); // Get our new name!

	if(fTargFile->GetFileName().GetLength() >= 10)
	{
		NewName = fTargFile->GetFileName().Mid(0,7); // Cut it up
		NewName = NewName + "..."; // Add 3 dots "..."
	}

	pwnd->SetDlgItemText(IDC_STATUS,"Downloading...");
	m_Prog->SetRange32(0,filesize); // Set range to file size(32bit range for big files)
	
	while (byteswrite = fTargFile->Read(filebuf, 512)) // Read from file
	{
		if(nTerminate == 1) // See if we got a Cancel requesst
		{
			fDestFile.Close(); // Close our destination file
			fTargFile->Close(); // Close remote file
			delete fTargFile; // Delete the CStdioFile object to prevent leaks
			pwnd->SetDlgItemText(IDC_STATUS,"Download cancelled by user"); // Set satus bar text
			AfxEndThread(0); // End thread
		}
		// Calculate total seconds between start of download up until now
		COleDateTimeSpan dlElapsed = COleDateTime::GetCurrentTime() - dlStart;
		// Get seconds between starting time and current time
		secs = dlElapsed.GetTotalSeconds();
		
		pos = pos + byteswrite; // Set new progress position value
		fDestFile.Write(filebuf, byteswrite); // Write actual data into file
		m_Prog->SetPos(pos); // Draw new position on progress bar
		
		// User info calculations -

		nperc = pos * 100 / filesize; // Calculate percentage
		kbrecv = pos / 1024; // Get received KB
		kbsec = kbrecv / secs; // Get KB download per second
		Perc.Format("%d",nperc); // Format percent into string
		KBin.Format("%d",kbrecv); // Format read KB into string
		KBsec.Format("%0.1f",kbsec); // Format KB/sec into string
		
		// Update GUI and all the good stuff
		
		pwnd->SetDlgItemText(IDC_KBSEC,KBsec + "kb/sec"); // Self explanitory
		pwnd->SetWindowText(NewName + " - " + Perc + "% | " + KBin + "kb/" + FileSize + "kb @ " + KBsec + "Kb/sec");
		pwnd->SetDlgItemText(IDC_PERC,Perc + "%");
		pwnd->SetDlgItemText(IDC_FS,"Downloaded : " + KBin + "kb/" + FileSize + "kb");
	}
	// Download ended, close file
	fDestFile.Close(); // Close our file
	}

	// Error did occour?
	catch(CInternetException *IE)
	{
		// Oh oh time to process error message and let the user know
		CString strerror; // String variable
		TCHAR error[255]; // Error message buffer
		IE->GetErrorMessage(error,255); // Get error message
		strerror = error; // Transfer into the CString object
		// Popup message to user
		pwnd->SetDlgItemText(IDC_STATUS,strerror);
		pwnd->SetDlgItemText(IDC_EXITCANCEL,"Exit"); // Return to normal mode
		nDownloaded = 0;
		delete fTargFile;
		IE->Delete(); // Delete exception object to prevent leaks
	}
	// Done downloading, what to do now?
	// Resetting GUI interfaces
	
	pwnd->SetDlgItemText(IDC_FS,"Downloaded : ");
	pwnd->SetWindowText("File Downloader");
	pwnd->SetDlgItemText(IDC_PERC,"0%");
	pwnd->SetDlgItemText(IDC_KBSEC,"0kb/sec");
	delete fTargFile;
	if(nDownloaded == 1)
	{
		pwnd->SetDlgItemText(IDC_STATUS,"Download complete");
		delete fTargFile;
	}
	m_Prog->SetPos(0); // Clear progress
	bGetFile->EnableWindow(TRUE); // Enable get file button
	pwnd->SetDlgItemText(IDC_EXITCANCEL,"Exit"); // Return to normal mode
	return 1;
}

// When user clicks Get File button
void CProgressExDlg::OnGetFile() 
{
	// Get pointer to the Get File button
	CButton* bGetFile = (CButton*)GetDlgItem(IDC_GETFILE);
	bGetFile->EnableWindow(FALSE); // Disable button
	SetDlgItemText(IDC_EXITCANCEL,"Cancel"); // Replace exit string on Exit button to Cancel
	nTerminate = 0; // Clear the Terminate value to 0 (starting a new download)
	// Begin our download thread
	CWinThread* pThread = AfxBeginThread(DownloadFile,GetSafeHwnd(),THREAD_PRIORITY_NORMAL);
}

void CProgressExDlg::OnExitCancel() 
{
	// Get pointer to the Get File button
	CButton* bGetFile = (CButton*)GetDlgItem(IDC_GETFILE);
	CString btnlabel; // String variables
	GetDlgItemText(IDC_EXITCANCEL,btnlabel); // Get current caption on the Exit/Cancel button
	// If cancel...
	if(btnlabel == "Cancel")
	{
		nTerminate = 1; // Direct to our thread to terminate
		// Reset GUI interface
		SetDlgItemText(IDC_FS,"Downloaded : ");
		SetWindowText("File Downloader");
		SetDlgItemText(IDC_PERC,"0%");
		SetDlgItemText(IDC_KBSEC,"0kb/sec");
		m_Prog.SetPos(0);
		SetDlgItemText(IDC_EXITCANCEL,"Exit"); // Change caption to Exit
		bGetFile->EnableWindow(TRUE); // Enable Get File button again
	}
	else
	{
		// Terminate program
		CDialog::OnOK();
	}
}